package xmlad;

import java.awt.Color;

import java.awt.Component;

import javax.swing.JTree;
import javax.swing.tree.DefaultTreeCellRenderer;

import org.w3c.dom.DocumentType;
import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;

public class XMLTreeCellRenderer extends DefaultTreeCellRenderer { 
    Color elementColor = new Color(0, 0, 128); 
    Color attributeColor = new Color(0, 128, 0); 
 
    public XMLTreeCellRenderer(){ 
        setOpenIcon(null); 
        setClosedIcon(null); 
        setLeafIcon(null); 
    } 
 
    public Component getTreeCellRendererComponent(JTree tree, Object value, boolean sel, boolean expanded, boolean leaf, int row, boolean hasFocus){ 
        Node node = (Node)value; 
        switch(node.getNodeType()){ 
            case Node.ELEMENT_NODE: 
                NamedNodeMap attrs = node.getAttributes(); 
                int attrCount = attrs!=null ? attrs.getLength() : 0; 
                String atributs = "";
                for(int i=0;i<attrCount;i++){atributs=atributs+" "+attrs.item(i).getNodeName()+"=\""+attrs.item(i).getNodeValue()+"\"";
                }
                value = '<'+node.getNodeName()+atributs+'>'+((node.getFirstChild()!=null&&node.getFirstChild().getNodeType()==Node.TEXT_NODE)?node.getFirstChild().getNodeValue()+"</"+node.getNodeName()+'>':"");
                break; 
            default: 
                value = node.getNodeName(); 
        } 
        super.getTreeCellRendererComponent(tree, value, sel, expanded, leaf, row, hasFocus); 
        if(!selected){ 
            switch(node.getNodeType()){ 
                case Node.ELEMENT_NODE: 
                    setForeground(elementColor); 
                    break; 
       
            } 
        } 
        return this; 
    } 
} 