package xmlad;

import java.awt.event.ComponentEvent;
import java.awt.event.MouseEvent;

import javax.swing.*;
import java.awt.*;
import java.awt.event.*;
import java.beans.*;

import java.util.List;
import java.util.ArrayList;

public class XmladDiagramPane extends JDesktopPane {
    private static int FRAME_OFFSET=20;
    private MDIDesktopManager manager;
    private XmladElement rootFrame;
    protected static List<XmladElementEdge> seznam_prechodu = new ArrayList<XmladElementEdge>(); 

    public XmladDiagramPane() {
        manager=new MDIDesktopManager(this);
        setDesktopManager(manager);
        setDragMode(JDesktopPane.OUTLINE_DRAG_MODE);
      
     
    }

    public void setBounds(int x, int y, int w, int h) {
        super.setBounds(x,y,w,h);
        checkDesktopSize();
    }

    public Component add(JInternalFrame frame) {
        JInternalFrame[] array = getAllFrames();
        Point p;
        int w;
        int h;
        Component retval=super.add(frame);
        checkDesktopSize();
        p = new Point(0, 0);
        
        moveToFront(frame);
        frame.setVisible(true);
        frame.pack();
        try {
            frame.setSelected(true);
        } catch (PropertyVetoException e) {
            frame.toBack();
        }
        return retval;
    }

    public void remove(Component c) {
        super.remove(c);
        checkDesktopSize();
    }

    public void setAllSize(Dimension d){
        setMinimumSize(d);
        setMaximumSize(d);
        setPreferredSize(d);
    }

  
    public void setAllSize(int width, int height){
  
        setAllSize(new Dimension(width,height));
    }

    private void checkDesktopSize() {
        if (getParent()!=null&&isVisible()) manager.resizeDesktop();
    }

   

    public void pridatXmladElement(XmladElement xmladElement,XmladElement parent)
    {
    if (xmladElement!=null){
    JInternalFrame array[] = getAllFrames();
    boolean vytvoritXmladElement=true;
    
    for (int i=0;i<array.length;i++) 
    {
    if(xmladElement.rootNodeList.equals(((XmladElement)array[i]).rootNodeList)) 
    {
    vytvoritXmladElement=false;
    }
    
    }
    if (vytvoritXmladElement){
    this.add(xmladElement);
    if (parent!=null&&xmladElement!=parent)
    {
        boolean vytvoritPrechod=true;
        for (int i=0;i<array.length;i++) 
        {
        if(parent.rootNodeList==((XmladElement)array[i]).rootNodeList) 
        {
        vytvoritPrechod=false;
        }
        
        }
        pridatPrechod(new XmladElementEdge(parent,xmladElement));
    }
    }
    }
    }
    
    public void odstranitXmladElement(XmladElement xmladElement)
    {
    if (xmladElement!=null){
    for(XmladElementEdge p: seznam_prechodu)
    {
    if(p!=null){
    if (p.vratFrom()==xmladElement||p.vratTo()==xmladElement)
        odstranitPrechod(p);
    }}
  //  this.remove(xmladElement);
    }
    }
    
    public void pridatPrechod(XmladElementEdge p)
    {
      if (p!=null)
       {
       seznam_prechodu.add(p);
       super.add(p);
       }
    
    }
    public void odstranitPrechod(XmladElementEdge p)
    {
        if (p!=null)
         {
         seznam_prechodu.remove(p);
       //  super.remove(p);
         }
    }

 

    
    public final static void nastavPrechody(){
        for (XmladElementEdge p : seznam_prechodu)
         {
          p.nastavSouradnice();
         }
    }
}


class MDIDesktopManager extends DefaultDesktopManager {
    private XmladDiagramPane desktop;

    public MDIDesktopManager(XmladDiagramPane desktop) {
        this.desktop = desktop;
    }

    public void endResizingFrame(JComponent f) {
        super.endResizingFrame(f);      
        resizeDesktop();
        XmladDiagramPane.nastavPrechody();
      
    }

    public void endDraggingFrame(JComponent f) {
        super.endDraggingFrame(f);
        resizeDesktop();
        XmladDiagramPane.nastavPrechody();
      
    }

    private Insets getScrollPaneInsets() {
        JScrollPane scrollPane=getScrollPane();
        if (scrollPane==null) return new Insets(0,0,0,0);
        else return getScrollPane().getBorder().getBorderInsets(scrollPane);
    }

    private JScrollPane getScrollPane() {
        if (desktop.getParent() instanceof JViewport) {
            JViewport viewPort = (JViewport)desktop.getParent();
            if (viewPort.getParent() instanceof JScrollPane)
                return (JScrollPane)viewPort.getParent();
        }
        return null;
    }

    protected void resizeDesktop() {
        int x = 0;
        int y = 0;
        JScrollPane scrollPane = getScrollPane();
        Insets scrollInsets = getScrollPaneInsets();

        if (scrollPane != null) {
            JInternalFrame allFrames[] = desktop.getAllFrames();
            for (int i = 0; i < allFrames.length; i++) {
                if (allFrames[i].getX()+allFrames[i].getWidth()>x) {
                    x = allFrames[i].getX() + allFrames[i].getWidth();
                }
                if (allFrames[i].getY()+allFrames[i].getHeight()>y) {
                    y = allFrames[i].getY() + allFrames[i].getHeight();
                }
            }
            Dimension d=scrollPane.getVisibleRect().getSize();
            if (scrollPane.getBorder() != null) {
               d.setSize(d.getWidth() - scrollInsets.left - scrollInsets.right,
                         d.getHeight() - scrollInsets.top - scrollInsets.bottom);
            }

            if (x <= d.getWidth()) x = ((int)d.getWidth()) - 20;
            if (y <= d.getHeight()) y = ((int)d.getHeight()) - 20;
            desktop.setAllSize(x,y);
            scrollPane.invalidate();
            scrollPane.validate();
         //   desktop.kresli(desktop.getGraphics(),5);
        }
    }
    
  
}