package xmlad;

import java.awt.Color;
import java.awt.Component;
import java.awt.Dimension;
import java.awt.Font;
import java.awt.Rectangle;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;
import java.awt.event.MouseAdapter;
import java.awt.event.MouseEvent;
import java.awt.event.MouseMotionAdapter;

import java.lang.Object;

import java.util.List;
import java.util.ArrayList;

import javax.swing.BoxLayout;
import javax.swing.JInternalFrame;
import javax.swing.JLabel;
import javax.swing.JMenuItem;
import javax.swing.JPopupMenu;
import javax.swing.JScrollPane;
import javax.swing.JTable;
import javax.swing.SwingConstants;
import javax.swing.event.InternalFrameAdapter;
import javax.swing.event.InternalFrameEvent;
import javax.swing.plaf.ComponentUI;
import javax.swing.plaf.basic.BasicInternalFrameUI;
import javax.swing.table.DefaultTableModel;


import javax.swing.table.TableCellRenderer;

import org.w3c.dom.NamedNodeMap;
import org.w3c.dom.Node;

public class XmladElement extends JInternalFrame{
    
    private XmladElement xmladElement;
    
    public static final int TYP_NULL = 0;
    public static final int TYP_ELEMENT = 1;
    public static final int TYP_AGREGACNI = 2;
    
    public static final int SHOW_ALL = 0;
    public static final int SHOW_MINIMAL = 1;
   
    
    private static final String HODNOTA = "Hodnota";
    private static final String JMENO_SUBELEMENTU = "Subelement";
    
    private static final String JMENO_ATRIBUTU = "Atribut";
    private static final String JMENO_ELEMENTU = "#Jmno";
    private static final String METADATA = "Metadata";
    
    private static final String ROZKLIKNI= "...->";
    
    /**Typ zobrazeni elementu*/
    private int showType = 0;
    /**Typ elementu*/
    private int typ = 1;
    
    /**Pozice na ploe*/
    private int x,y;
    
    /** Seznam XML elementu, ktere reprezentuje tento Element*/
     public ArrayList<Node> rootNodeList = new ArrayList<Node>(); 
   
    /**Nzev Xmlad elemetu*/
    private JLabel labelName = new JLabel();
    
   
   private Node rootNode = null;
   /**Pomocny XML element*/
   private Node currentNode = null;
   
 
            
    /*Tabulky TYP_ELEMENT*/
    private DefaultTableModel dataElementTableModel = new DefaultTableModel(){ 
    public boolean isCellEditable(int rowIndex, int mColIndex) {
            return false;}};
    private TableSorter dataElementTableSorter = new TableSorter(dataElementTableModel);            
    private JTable dataElementTable = new JTable(dataElementTableSorter);
    private JScrollPane dataElementTableScrollPane = new JScrollPane(dataElementTable);
    
    
    
    
    protected ArrayList<List> dataElementListNodeList = new ArrayList<List>();
    protected ArrayList<String> dataElementStringList = new ArrayList<String>();
    
    private DefaultTableModel atributyElementTableModel = new DefaultTableModel(){
    public boolean isCellEditable(int rowIndex, int mColIndex) {
            return false;}};
    private TableSorter atributyElementTableSorter = new TableSorter(atributyElementTableModel);
    private JTable atributyElementTable = new JTable(atributyElementTableSorter);
    private JScrollPane atributyElementTableScrollPane = new JScrollPane(atributyElementTable);
    /*Tabulky TYP_ELEMENT*/
    
    /*Tabulky TYP_AGREGACNI*/
    private DefaultTableModel agregacniDataElementTableModel = new DefaultTableModel(){
    public boolean isCellEditable(int rowIndex, int mColIndex) {
            return false;}};
    private TableSorter agregacniDataElementTableSorter = new TableSorter(agregacniDataElementTableModel);
    private JTable agregacniDataElementTable = new JTable(agregacniDataElementTableSorter);
    private JScrollPane agregacniDataElementTableScrollPane = new JScrollPane(agregacniDataElementTable);
    
    private DefaultTableModel metaDataTableModel = new DefaultTableModel(){   
    public boolean isCellEditable(int rowIndex, int mColIndex) {
            return false;}};
    private TableSorter metaDataTableSorter = new TableSorter(metaDataTableModel);            
    private JTable metaDataTable = new JTable(metaDataTableSorter);
    private JScrollPane metaDataTableScrollPane = new JScrollPane(metaDataTable);
    /*Tabulky TYP_AGREGACNI*/
    
    
    
  
    
    /**Popou menu pro upravy velikosti elementu*/
    private JPopupMenu labelNamePopupMenu = new JPopupMenu();
    private JMenuItem jMenuItemZobrazitMinimalne = new JMenuItem();
    private JMenuItem jMenuItemZobrazitVse = new JMenuItem();

    private BoxLayout boxLayout = new BoxLayout(this.getContentPane(),BoxLayout.Y_AXIS);


    public XmladElement(Node node) {
       this.typ=TYP_ELEMENT;
       this.rootNode=node;
       this.rootNodeList.add(node);
       this.xmladElement = this;
       if (this.rootNodeList!=null){
        try {
            
            jbInit();
            
        } catch (Exception e) {
            e.printStackTrace();
        }
          
       }
       
       
    }
    
    public XmladElement(ArrayList<Node> nodeList) {
       this.rootNode=nodeList.get(0);
       this.rootNodeList=nodeList;
       this.xmladElement = this;
       if(nodeList.size()>1)
         this.typ=TYP_AGREGACNI;
       else
         this.typ=TYP_ELEMENT;
       
       if (this.rootNodeList!=null){
        try {
            
            jbInit();
           
        } catch (Exception e) {
            e.printStackTrace();
        }
         
       }
    }
    public XmladElement(ArrayList<Node> nodeList, int typ) {
       this.rootNode=nodeList.get(0);
       this.rootNodeList=nodeList;
       this.typ=typ;
       
       if (this.rootNodeList!=null){
        try {
            
            jbInit();
           
        } catch (Exception e) {
            e.printStackTrace();
        }
           
       }
    }
    
    private void jbInit() throws Exception {
        /*Odstraneni hlavicky internal framu*/
        ComponentUI frameUI = this.getUI();
             if (frameUI instanceof BasicInternalFrameUI) {               
             ((BasicInternalFrameUI)getUI()).getNorthPane().setPreferredSize(new Dimension(0,0));
        }
        
        
        this.setOpaque(false);
        this.setSelected(true);
        this.setResizable(true);
        this.setToolTipText(null);
        this.setFocusable(false);
        this.setFocusCycleRoot(false);
        this.getContentPane().setLayout(boxLayout);
        this.setRequestFocusEnabled(false);
        this.setVerifyInputWhenFocusTarget(false);
        this.setVisible(true);
        this.setClosable(false);
        this.setBounds(new Rectangle(0, 0, 100, 100));

        this.addInternalFrameListener(new InternalFrameAdapter() {
                    public void internalFrameActivated(InternalFrameEvent e) {
                        this_internalFrameActivated(e);
                    }

                    public void internalFrameDeactivated(InternalFrameEvent e) {
                        this_internalFrameDeactivated(e);
                    }
                });
        switch (typ){
            case TYP_ELEMENT: 
                dataElementTableModel.addColumn(JMENO_SUBELEMENTU);
                dataElementTableModel.addColumn(HODNOTA);
                
                currentNode=this.rootNode.getFirstChild();
                while (currentNode!=null)
                {    
                if (currentNode.getNodeType()==Node.ELEMENT_NODE)
                {
                             
                    int index=dataElementStringList.indexOf(currentNode.getNodeName());
                    if(index>=0)
                        {
                            (dataElementListNodeList.get(index)).add(currentNode);
                            
                        }
                     else {
                                ArrayList<Node> testNodeList = new ArrayList<Node>();
                                testNodeList.add(currentNode);
                                dataElementListNodeList.add(testNodeList);
                            
                                dataElementStringList.add(currentNode.getNodeName());
                            }
                }
                currentNode=currentNode.getNextSibling();
                }
                for(List list : dataElementListNodeList){
                    Object row[] = {list,list};
                        dataElementTableModel.addRow(row);
                }  
                
                if (dataElementTable.getRowCount()>0){
                
                dataElementTable.setDefaultRenderer(Object.class,new XmladDataElementTableCellRenderer());
                
                dataElementTableSorter.setTableHeader(dataElementTable.getTableHeader());
                }
                else
                {
                dataElementTable.setTableHeader(null);
                }
              //  zobrazitTabulky.add(dataElementTable);
                
                atributyElementTableModel.addColumn(JMENO_ATRIBUTU);
                atributyElementTableModel.addColumn(HODNOTA);
                
                if (this.rootNode!=null&&this.rootNode.hasAttributes())
                {
                    NamedNodeMap namedNodeMap = this.rootNode.getAttributes();
                    for(int i=0;i<namedNodeMap.getLength();i++)
                    {
                      Object row[] ={namedNodeMap.item(i).getNodeName(),namedNodeMap.item(i).getNodeValue()};
                      atributyElementTableModel.addRow(row);
                    }
                    //zobrazitTabulky.add(atributyElementTable);
                }
                currentNode=this.rootNode.getFirstChild();
                while (currentNode!=null){
                if (currentNode.getNodeType()==Node.TEXT_NODE)
                {
                    Object row[] ={currentNode.getNodeName(),currentNode.getNodeValue()};
                    atributyElementTableModel.addRow(row);
                
                }
                    currentNode=currentNode.getNextSibling();
                }
                
                if (atributyElementTableModel.getRowCount()>0){
                
                atributyElementTable.setTableHeader(atributyElementTable.getTableHeader());
                }
                else
                {
                atributyElementTable.setTableHeader(null);
                }
                
                
            break;
            
            case TYP_AGREGACNI:
                agregacniDataElementTableModel.addColumn(JMENO_ELEMENTU);
                for(Node currentNode : rootNodeList){
                    // n=n.getFirstChild();
                     if(currentNode.getFirstChild()!=null&&currentNode.getFirstChild().getNodeType()==Node.TEXT_NODE)
                     if(agregacniDataElementTableModel.findColumn(currentNode.getFirstChild().getNodeName())<0)
                         {
                         agregacniDataElementTableModel.addColumn(currentNode.getFirstChild().getNodeName());
                         }
                     if(currentNode.hasAttributes()){
                     NamedNodeMap namedNodeMap = currentNode.getAttributes();
                         
                     for(int i=0;i<namedNodeMap.getLength();i++){
                     if(agregacniDataElementTableModel.findColumn(namedNodeMap.item(i).getNodeName())<0)
                     {
                     agregacniDataElementTableModel.addColumn(namedNodeMap.item(i).getNodeName());
                     }
                    
                     }
                     }
                }
                for(Node currentNode : rootNodeList){
                    Object row[] = new Object[agregacniDataElementTableModel.getColumnCount()];
                    row[agregacniDataElementTableModel.findColumn(JMENO_ELEMENTU)] = currentNode;
                    
                    if(currentNode.getFirstChild()!=null&&currentNode.getFirstChild().getNodeType()==Node.TEXT_NODE)
                    {     
                    
                    if(agregacniDataElementTableModel.findColumn(currentNode.getFirstChild().getNodeName())>=0)
                      row[agregacniDataElementTableModel.findColumn(currentNode.getFirstChild().getNodeName())] = currentNode.getFirstChild();
                    }
                     if(currentNode.hasAttributes()){
                     NamedNodeMap namedNodeMap = currentNode.getAttributes();
                         
                     for(int i=0;i<namedNodeMap.getLength();i++){
                     
                     row[agregacniDataElementTableModel.findColumn(namedNodeMap.item(i).getNodeName())] = namedNodeMap.item(i);
                     
                     
                     }
                     
                     }
                     
                     
                    agregacniDataElementTableModel.addRow(row);
                
                                    
                }
                   if (agregacniDataElementTable.getRowCount()>0){
                   agregacniDataElementTable.setDefaultRenderer(Object.class,new XmladAgregacniDataElementTableCellRenderer());
                   
                   agregacniDataElementTableSorter.setTableHeader(agregacniDataElementTable.getTableHeader());
                   }
                   else
                   {
                   agregacniDataElementTable.setTableHeader(null);
                   }
                   
                   
                metaDataTableModel.addColumn(METADATA);
                ArrayList<String> nameNodeList = new ArrayList<String>(); 
                for(Node currentNode : rootNodeList){
                    currentNode=currentNode.getFirstChild();
                   
                    
                       while (currentNode!=null)
                        {
                            if (currentNode.getNodeType()==Node.ELEMENT_NODE){
                            
                                    
                            int index=nameNodeList.indexOf(currentNode.getNodeName());
                            if(index>=0)
                                {
                                   
                                }
                                else {
                                
                                        nameNodeList.add(currentNode.getNodeName());
                                        Object[] row = {currentNode.getNodeName()};
                                        metaDataTableModel.addRow(row);
                                        
                                    }
                                }
                            currentNode=currentNode.getNextSibling();
                        }
                  
                 
                    
                }
                 
                if (metaDataTable.getRowCount()>0){
                  metaDataTableSorter.setTableHeader(metaDataTable.getTableHeader());
                }
             
            break;
            default:
            break;
            } 
     
        /*Nastaveni nadpisu elementu*/
        if(rootNodeList.size()>1){
            labelName.setText(rootNodeList.get(0).getNodeName()+" ("+rootNodeList.size()+")");
            
        }
        else
        {    
        labelName.setText(rootNodeList.get(0).getNodeName());
        }
        labelName.setHorizontalAlignment(SwingConstants.CENTER);
        labelName.setFont(new Font("Dialog", 1, 12));
        labelName.setForeground(new Color(0, 0, 132));
        labelName.setComponentPopupMenu(labelNamePopupMenu);
        labelName.setAlignmentX((float) 0.5);
        labelName.setMaximumSize(new Dimension(32767, 23));
        labelName.setMinimumSize(new Dimension(100, 23));
        labelName.setPreferredSize(new Dimension(150, 23));
        labelName.setHorizontalTextPosition(SwingConstants.CENTER);
        labelName.setOpaque(true);
        JInternalFrame jjj = new JInternalFrame();
        
        
        labelName.addMouseMotionListener(new MouseMotionAdapter() {
           public void mouseDragged(MouseEvent e) {
               labelName_mouseDragged(e);
           }
        });
        labelName.addMouseListener(new MouseAdapter() {
           public void mousePressed(MouseEvent e) {
               labelName_mousePressed(e);
           }

           public void mouseReleased(MouseEvent e) {
               labelName_mouseReleased(e);
           }
        });
        this.getContentPane().add(labelName);

        
        dataElementTable.addMouseListener(new MouseAdapter() {
                    public void mouseClicked(MouseEvent e) {
                        dataElementTable_mouseClicked(e);
                    }
                });
        
        
        
        
        agregacniDataElementTable.addMouseListener(new MouseAdapter() {
                    public void mouseClicked(MouseEvent e) {
                        agregacniDataElementTable_mouseClicked(e);
                    }
                });
        metaDataTable.addMouseListener(new MouseAdapter() {
                    public void mouseClicked(MouseEvent e) {
                        metaDataTable_mouseClicked(e);
                    }
                });
        
        
       

        
     
        
       
      
   
     //   this.setMinimumSize(new Dimension(75,46));
        
        switch(typ){
            case TYP_ELEMENT: 
         
            atributyElementTable.setPreferredScrollableViewportSize(new Dimension(150,atributyElementTable.getRowHeight()*atributyElementTable.getRowCount()));
            dataElementTable.setPreferredScrollableViewportSize(new Dimension(dataElementTable.getWidth(),dataElementTable.getRowHeight()*dataElementTable.getRowCount()));
            this.getContentPane().add(atributyElementTableScrollPane,null);
            this.getContentPane().add(dataElementTableScrollPane,null);
            
            
            
            break;
        case TYP_AGREGACNI:
            agregacniDataElementTable.setPreferredScrollableViewportSize(new Dimension(150,agregacniDataElementTable.getRowHeight()*agregacniDataElementTable.getRowCount()));
            metaDataTable.setPreferredScrollableViewportSize(new Dimension(150,metaDataTable.getRowHeight()*metaDataTable.getRowCount()));
            this.getContentPane().add(agregacniDataElementTableScrollPane,null);
            this.getContentPane().add(metaDataTableScrollPane,null);            
            
        break;
        default:
        break;
        }
        

        labelNamePopupMenu.add(jMenuItemZobrazitVse);
        labelNamePopupMenu.add(jMenuItemZobrazitMinimalne);

        jMenuItemZobrazitMinimalne.setText("Zobrazit pouze nzev");
        jMenuItemZobrazitMinimalne.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        jMenuItemZobrazitMinimalne_actionPerformed(e);
                    }
                });
        jMenuItemZobrazitVse.setText("Zobrazit ve");
        jMenuItemZobrazitVse.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        jMenuItemZobrazitVse_actionPerformed(e);
                    }
                });
      
        
      
  
    }
   

    private void labelName_mouseDragged(MouseEvent e) {
        this.getDesktopPane().getDesktopManager().dragFrame(this,this.x+e.getX()>0?this.x+e.getX():0,this.y+e.getY()>0?this.y+e.getY():0);
     
    }

    private void labelName_mousePressed(MouseEvent e) {
        this.getDesktopPane().getDesktopManager().beginDraggingFrame(this);
        this.x=this.getX()-e.getX();
        this.y=this.getY()-e.getY();
    }

    private void labelName_mouseReleased(MouseEvent e) {
        this.getDesktopPane().getDesktopManager().endDraggingFrame(this);
      
    }

    private void setShowSize(int type)
    {
    switch (type) {
          case SHOW_ALL: 
              this.showType = SHOW_ALL;
          break;
         
          case SHOW_MINIMAL: 
              this.showType = SHOW_MINIMAL;
          break;
         
          default:
          this.showType = SHOW_ALL;
          break;
      }
    switch(this.showType)
    {
        case SHOW_ALL:
        pack();
        break;
      
        case SHOW_MINIMAL: 
        this.setSize(new Dimension(this.getWidth(),(int)labelName.getMinimumSize().getHeight()));
        
        break;
      
    
    }
    ((XmladDiagramPane) this.getDesktopPane()).nastavPrechody();
    }
    
     
    
   

    private void jMenuItemZobrazitVse_actionPerformed(ActionEvent e) {
        this.setShowSize(SHOW_ALL);
    }

    private void jMenuItemZobrazitMinimalne_actionPerformed(ActionEvent e) {
        this.setShowSize(SHOW_MINIMAL);
    }


    private void dataElementTable_mouseClicked(MouseEvent e) {
     if (e.getClickCount()==2){
         ((XmladDiagramPane)this.getDesktopPane()).pridatXmladElement(new XmladElement(((ArrayList<Node>)dataElementTable.getValueAt(dataElementTable.getSelectedRow(),dataElementTable.getSelectedColumn()))),this);        
         
        }
       
        
    }

    private void agregacniDataElementTable_mouseClicked(MouseEvent e) {
        if (e.getClickCount()==2){
            ((XmladDiagramPane)this.getDesktopPane()).pridatXmladElement(new XmladElement(((Node)agregacniDataElementTable.getValueAt(agregacniDataElementTable.getSelectedRow(),agregacniDataElementTableModel.findColumn(JMENO_ELEMENTU)))),this);
           
           }
          
    }

    private void metaDataTable_mouseClicked(MouseEvent e) {
    if (e.getClickCount()==2){
    if (!(agregacniDataElementTableModel.findColumn("./"+metaDataTable.getValueAt(metaDataTable.getSelectedRow(),0))>=0))
    {
        agregacniDataElementTableModel.addColumn("./"+metaDataTable.getValueAt(metaDataTable.getSelectedRow(),0));
        for (int i=0;i<agregacniDataElementTable.getRowCount();i++)
        {
            
          
          Node currentNode = (Node)agregacniDataElementTableModel.getValueAt(i,agregacniDataElementTableModel.findColumn(JMENO_ELEMENTU));
          ArrayList<Node> arrayNodeList = new ArrayList<Node>();
          currentNode=currentNode.getFirstChild();
          while(currentNode!=null)
          {
              if (currentNode.getNodeName()==metaDataTable.getValueAt(metaDataTable.getSelectedRow(),0))
                  arrayNodeList.add(currentNode);
              currentNode=currentNode.getNextSibling();
          }
         
            
            
            agregacniDataElementTableModel.setValueAt(arrayNodeList,i,agregacniDataElementTableModel.findColumn("./"+metaDataTable.getValueAt(metaDataTable.getSelectedRow(),0)));
        }
    }
    
    
    }
    }

    private void this_internalFrameActivated(InternalFrameEvent e) {
        
        labelName.setBackground(Color.BLACK);
        labelName.setForeground(Color.WHITE);
        
        
        
    }

    private void this_internalFrameDeactivated(InternalFrameEvent e) {
        labelName.setBackground(getBackground());
        labelName.setForeground(new Color(0, 0, 132));
    }


    public class XmladDataElementTableCellRenderer extends JLabel implements TableCellRenderer{
        public Component getTableCellRendererComponent(JTable table, 
                                                       Object value, 
                                                       boolean isSelected, 
                                                       boolean hasFocus, 
                                                       int row, int column) {
            
            ArrayList<Node> dataElementNodeList = (ArrayList<Node>)value;
            setOpaque(true);
            if (isSelected) 
            {
                setBackground(table.getSelectionBackground());
                setForeground(Color.WHITE);
            }
            else
            {
                setBackground(Color.WHITE);
                setForeground(Color.BLACK);
            }   
            
            
           if (table.getColumnName(column)==JMENO_SUBELEMENTU)
            {
                setText(dataElementNodeList.get(0).getNodeName());
                setHorizontalAlignment(JLabel.LEFT);
            }
          else if (table.getColumnName(column)==HODNOTA)
            {
                setHorizontalAlignment(JLabel.RIGHT);
              if (dataElementNodeList.size()==1)
              {
                if (dataElementNodeList.get(0).getFirstChild()!=null){
                if(dataElementNodeList.get(0).getFirstChild().getNodeType()==Node.TEXT_NODE)
                  {
                  setText(dataElementNodeList.get(0).getFirstChild().getNodeValue());
                  }
                  else {
                      setText(ROZKLIKNI);
                  }
                  
                }
                else
                    setText("");
              }
              else
                  setText(ROZKLIKNI);
            }
           
           
            
            return this;
        }
    }

    public class XmladElementTableCellRenderer extends JLabel implements TableCellRenderer {
             public Component getTableCellRendererComponent(JTable table, Object value,
                    boolean isSelected, boolean hasFocus, int rowIndex, int vColIndex) {
                
                ArrayList<Node> elementNodeList = (ArrayList<Node>)value;
                setOpaque(true);
                
                if (isSelected) {
                    setBackground(table.getSelectionBackground());
                    setForeground(Color.WHITE);
                }
                else
                {
                    setBackground(Color.WHITE);
                    setForeground(Color.BLACK);
                }      
                setText(elementNodeList.get(0).getNodeName());
        
                return this;
            }
        
         
        } 
    public class XmladValueTableCellRenderer extends JLabel implements TableCellRenderer {
           public Component getTableCellRendererComponent(JTable table, Object value,
                   boolean isSelected, boolean hasFocus, int rowIndex, int vColIndex) {
         
               setOpaque(true);
               
               if (isSelected) {
                   setBackground(table.getSelectionBackground());
                   setForeground(Color.RED);
               }
               else
               {
                   setBackground(table.getBackground());
                   setForeground(table.getForeground());
               }      
               if (rowIndex==0)
               {
                   setFont(new Font("Dialog", 1, 12));
                   setBackground(Color.GRAY);
                   setForeground(Color.RED);
               }
               else
               {
                   setFont(table.getFont());
               setBackground(table.getBackground());
               }
               
               
               if (value!=null)
                 setText(value.toString());
                else
                 setText("");
       
               return this;
           }
       
       } 
    
    public class XmladAgregacniDataElementTableCellRenderer extends JLabel implements TableCellRenderer {
          
           public Component getTableCellRendererComponent(JTable table, 
                                                          Object value, 
                                                          boolean isSelected, 
                                                          boolean hasFocus, 
                                                          int row, int column) {
               
               
               setOpaque(true);
               if (isSelected) 
               {
                   setBackground(table.getSelectionBackground());
                   setForeground(Color.WHITE);
               }
               else
               {
                   setBackground(Color.WHITE);
                   setForeground(Color.BLACK);
               }   
               
           if (value!=null){
             
           ArrayList<Node> nodeList = new ArrayList<Node>();
                if (value.getClass() == ArrayList.class) {
                    nodeList = (ArrayList<Node>)value;
                } else {
                    nodeList.add((Node)value);
                    
                }
              
                
               if (table.getColumnName(column)==JMENO_ELEMENTU)
               {
                   setText(nodeList.get(0).getNodeName());
                   setHorizontalAlignment(JLabel.LEFT);
               }
             else 
               {
                   setHorizontalAlignment(JLabel.RIGHT);
                   if (value.getClass() == ArrayList.class) {
                       if (nodeList.size()==1)
                       {
                         if (nodeList.get(0).getFirstChild()!=null){
                         if(nodeList.get(0).getFirstChild().getNodeType()==Node.TEXT_NODE)
                           {
                           setText(nodeList.get(0).getFirstChild().getNodeValue());
                           }
                           else {
                               setText(ROZKLIKNI);
                           }
                           
                         }
                         else{
                             setText("");
                           setBackground(Color.LIGHT_GRAY);
                           }
                       }
                       else if (nodeList.size()>1)
                           setText(ROZKLIKNI);
                       else    
                       {
                          setText("");
                          setBackground(Color.LIGHT_GRAY);
                          }
                   } else {
                       setText(nodeList.get(0).getNodeValue());
                       
                   }
              
               }
              
            }
            else {
            setText("");
            setBackground(Color.LIGHT_GRAY);
            }   
               return this;
               } }
       
   

}


