package xmlad;

import java.awt.BorderLayout;

import java.awt.Event;
import java.awt.event.ActionEvent;
import java.awt.event.ActionListener;

import java.awt.event.KeyEvent;

import java.awt.event.MouseAdapter;

import java.awt.event.MouseEvent;

import java.io.FileInputStream;


import javax.swing.ImageIcon;
import javax.swing.JButton;

import javax.swing.JFileChooser;
import javax.swing.JFrame;

import javax.swing.JLabel;
import javax.swing.JMenu;
import javax.swing.JMenuBar;
import javax.swing.JMenuItem;
import javax.swing.JOptionPane;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSplitPane;

import javax.swing.JToolBar;
import javax.swing.JTree;

import javax.swing.KeyStroke;
import javax.swing.event.TreeSelectionEvent;
import javax.swing.event.TreeSelectionListener;

import org.w3c.dom.Node;

import org.xml.sax.InputSource;

import xmlad.filters.XmlFilter;


public class XmladGUI extends JFrame {
   
    private BorderLayout layoutMain = new BorderLayout();
    private JPanel panelCenter = new JPanel();
    private JMenuBar menuBar = new JMenuBar();
    private JMenu menuFile = new JMenu();
    private JMenuItem menuFileExit = new JMenuItem();
    private JMenu menuHelp = new JMenu();
    private JMenuItem menuHelpAbout = new JMenuItem();
    private JMenuItem menuOpenXML = new JMenuItem();
    private JMenuItem menuClose = new JMenuItem();
    private JLabel statusBar = new JLabel();
    private JToolBar toolBar = new JToolBar();
    private JButton buttonOpen = new JButton();
    private JButton buttonClose = new JButton();
    private JButton buttonHelp = new JButton();
    private ImageIcon imageOpen = new ImageIcon(XmladGUI.class.getResource("openfile.gif"));
    private ImageIcon imageClose = new ImageIcon(XmladGUI.class.getResource("closefile.gif"));
    private ImageIcon imageHelp = new ImageIcon(XmladGUI.class.getResource("help.gif"));
    private BorderLayout borderLayout1 = new BorderLayout();
    
  
    private XmladElement rootXmladElement;// = new XmladElement();
    private JSplitPane jSplitPaneMain = new JSplitPane();
    private JScrollPane jScrollPaneTree = new JScrollPane();
    
    private JSplitPane jSplitPane1 = new JSplitPane();
   
    private JScrollPane jScrollDiagram = new JScrollPane();
    private XmladDiagramPane xmladDiagramPane1 = new XmladDiagramPane();
    private JFileChooser xmlFileChooser = new JFileChooser();
    private XmlFilter filter = new XmlFilter();
    private XMLTreeModel xmltreemodel;// = new XMLTreeModel();
    private JTree jTree1 = new JTree(xmltreemodel);
    private XMLTreeCellRenderer xmlTreeCellRenderer = new XMLTreeCellRenderer();
    private JMenuItem jMenuItem1 = new JMenuItem();
    private XmladHelp xmladHelp= new XmladHelp();

    public XmladGUI() {
        try {
            jbInit();
        } catch (Exception e) {
            e.printStackTrace();
        }
    }

    private void jbInit() throws Exception {
        this.setJMenuBar( menuBar );
        this.getContentPane().setLayout( layoutMain );
        panelCenter.setLayout(borderLayout1);
        
        
        menuFile.setText( "Soubor" );
        menuFileExit.setText( "Konec" );
        menuFileExit.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F4, Event.ALT_MASK, false));
        menuFileExit.addActionListener( new ActionListener() { public void actionPerformed( ActionEvent ae ) { fileExit_ActionPerformed( ae ); } } );
        menuFile.add(menuOpenXML);
        menuFile.add(menuClose);
        menuFile.addSeparator();
        menuFile.add(menuFileExit);
          menuBar.add(menuFile);
        menuHelp.add(jMenuItem1);
        menuHelp.add(menuHelpAbout);
        menuBar.add(menuHelp);
        menuHelp.setText("Npovda");
        menuOpenXML.setText("Otevt XML");
        menuOpenXML.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_N, 
                                                          Event.CTRL_MASK, 
                                                          false));

        menuOpenXML.setIcon(imageOpen);
        menuOpenXML.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        menuOpenXML_actionPerformed(e);
                    }
                });
        menuClose.setText("Zavt");
        menuClose.setAccelerator(KeyStroke.getKeyStroke(KeyEvent.VK_F4, 
                                                        Event.CTRL_MASK, 
                                                        false));

        menuClose.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        menuClose_actionPerformed(e);
                    }
                });
        menuHelpAbout.setText("O Programu");
        menuHelpAbout.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent ae) {
                        helpAbout_ActionPerformed(ae);
                    }
                });


        menuFile.add(menuFileExit);
        menuBar.add(menuFile);
        menuHelp.add(menuHelpAbout);
        menuBar.add(menuHelp);
        statusBar.setText("");
        buttonOpen.setToolTipText("Open File");
        buttonOpen.setIcon(imageOpen);
        buttonOpen.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        menuOpenXML_actionPerformed(e);
                    }
                });
        buttonClose.setToolTipText("Close File");
        buttonClose.setIcon(imageClose);
        buttonClose.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        menuClose_actionPerformed(e);
                    }
                });
        buttonHelp.setToolTipText("About");
        buttonHelp.setIcon(imageHelp);

        buttonHelp.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        buttonHelp_actionPerformed(e);
                    }
                });
        toolBar.add(buttonOpen);
        toolBar.add(buttonClose);
        toolBar.add(buttonHelp);
        this.getContentPane().add(toolBar, BorderLayout.NORTH);
        this.getContentPane().add(statusBar, BorderLayout.SOUTH);
        jSplitPaneMain.setOrientation(JSplitPane.HORIZONTAL_SPLIT);
        jSplitPaneMain.setDividerSize(3);
        jSplitPaneMain.setDividerLocation(120);
        jTree1.setDragEnabled(true);

        jTree1.addTreeSelectionListener(new TreeSelectionListener() {
                    public void valueChanged(TreeSelectionEvent e) {
                        jTree1_valueChanged(e);
                    }
                });
        jTree1.addMouseListener(new MouseAdapter() {
                    public void mousePressed(MouseEvent e) {
                        jTree1_mousePressed(e);
                    }
                });
        jMenuItem1.setText("Npovda");
        jMenuItem1.addActionListener(new ActionListener() {
                    public void actionPerformed(ActionEvent e) {
                        jMenuItem1_actionPerformed(e);
                    }
                });
        jSplitPane1.setOrientation(JSplitPane.VERTICAL_SPLIT);
        jSplitPane1.setDividerLocation(200);


        this.getContentPane().add(panelCenter, BorderLayout.CENTER);
        jScrollPaneTree.getViewport().add(jTree1, null);
        jSplitPaneMain.add(jScrollPaneTree, JSplitPane.LEFT);
        jScrollDiagram.getViewport().add(xmladDiagramPane1, null);
        jSplitPaneMain.add(jScrollDiagram, JSplitPane.RIGHT);

        this.getContentPane().add(jSplitPaneMain, BorderLayout.CENTER);

        xmlFileChooser.setApproveButtonText("Otevt");
        xmlFileChooser.setDialogTitle("Otevt XML");
        if (filter != null)
            xmlFileChooser.addChoosableFileFilter(filter);
        xmlFileChooser.setAcceptAllFileFilterUsed(false);
        xmlFileChooser.setApproveButtonToolTipText("null");
        xmlFileChooser.setFileFilter(filter);
        xmlFileChooser.setOpaque(true);

    }

    void fileExit_ActionPerformed(ActionEvent e) {
        System.exit(0);
    }

    void helpAbout_ActionPerformed(ActionEvent e) {
        JOptionPane.showMessageDialog(this, new XmladGUI_AboutBoxPanel1(), "About", JOptionPane.PLAIN_MESSAGE);
    }

    private void menuOpenXML_actionPerformed(ActionEvent e)  {
        if(xmlFileChooser.showOpenDialog(this)==JFileChooser.APPROVE_OPTION)
        {
            


            try {
                xmltreemodel = new XMLTreeModel(new InputSource(new FileInputStream(xmlFileChooser.getSelectedFile().getAbsolutePath())));
                
                jTree1.setModel(xmltreemodel);
                jTree1.setCellRenderer(xmlTreeCellRenderer);
                rootXmladElement = new XmladElement((Node)xmltreemodel.getRoot());
                 xmladDiagramPane1 = new XmladDiagramPane();
                 jScrollDiagram.getViewport().add(xmladDiagramPane1, null);
                 xmladDiagramPane1.add(rootXmladElement);
                 rootXmladElement.pack();
                 
                } catch (Exception f) {
                JOptionPane.showMessageDialog(null,"Soubor " + xmlFileChooser.getSelectedFile().getAbsolutePath() + " nen ve sprvnm formtu XML nebo nelze otevt.","Chyba!",JOptionPane.ERROR_MESSAGE);
                 
            }
        }

    }

    private void jTree1_valueChanged(TreeSelectionEvent e) {
    
        
      
    }

    private void jTree1_mousePressed(MouseEvent e) {
    
    }


    

    private void menuClose_actionPerformed(ActionEvent e) {
    jTree1.setModel(null);
        xmladDiagramPane1 = new XmladDiagramPane();
        //jScrollDiagram.removeAll();
        jScrollDiagram.getViewport().add(xmladDiagramPane1, null);
    }


    private void buttonHelp_actionPerformed(ActionEvent e) {
        xmladHelp.setVisible(true);
    }

    private void jMenuItem1_actionPerformed(ActionEvent e) {
    
    xmladHelp.setVisible(true);
    }
}
